// Avatar app

angular.module('app', ['ionic','ionic.service.core', 'ionic-color-picker', 'app.controllers', 'app.services', 'ngCordova', 'ngResource', 'angularLazyImg'])

.constant('PREFERENCES', {
  apiIP: 'tubeheroes.com',
  apiUrl: function() {
    return 'https://' + this.apiIP + '/api/v1';
  },
  timeOut: 100000
})

.run(function($ionicPlatform) {
  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
      cordova.plugins.Keyboard.disableScroll(true);

    }
    if (window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleDefault();
    }
    if(typeof analytics != undefined) {
      window.analytics.startTrackerWithId("UA-62994710-3");
    } else {
      console.log("Google Analytics unavailable");
    }
  });
})

.factory('maleAssets', function(assetService) {
  return assetService.AllAssets('male').$promise.then(
    function(data) {
      return data;
    },
    function(httpResponse) {
      console.log(httpResponse);
    }
  );
})

.factory('femaleAssets', function(assetService) {
  return assetService.AllAssets('female').$promise.then(
    function(data) {
      return data;
    },
    function(httpResponse) {
      console.log(httpResponse);
    }
  );
})

.config(function($stateProvider, $urlRouterProvider, $ionicConfigProvider) {

  $ionicConfigProvider.views.maxCache(0);
  $ionicConfigProvider.tabs.style('standard');
  $ionicConfigProvider.tabs.position('bottom');

  $stateProvider

  .state('start', {
    url: '/start',
    templateUrl: 'templates/start.html',
    controller: 'StartCtrl'
  })

  .state('app', {
    url: '/app',
    templateUrl: 'templates/app.html',
    controller: 'AppCtrl'
  });

  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/start');

});
