angular.module('app.controllers', [])

.controller('AppCtrl', ['$scope', '$rootScope', '$window', '$ionicModal', '$ionicPopup', '$ionicNavBarDelegate', 'maleAssets', 'femaleAssets',  function($scope, $rootScope, $window, $ionicModal, $ionicPopup, $ionicNavBarDelegate, maleAssets, femaleAssets) {

  // minimum height and width to use for canvas
  $scope.minHeight = $window.innerHeight - 69;
  $scope.minWidth = $window.innerWidth - 20;

  $scope.type = '';

  // model
  var typeList = {
    'Head': [
      {title: 'Eyes'},
      {title: 'Hair'},
      {title: 'Mouth'},
    ],
    'Clothes': [
      {title: 'Bottoms'},
      {title: 'Top'}
    ],
    'Shoes': [],
    'Accessories': [
      {title: 'Accessories'},
      {title: 'Belt'},
      {title: 'Glasses'},
      {title: 'Hat'},
      {title: 'Necklace'},
      {title: 'Scarf'},
    ],
    'Backgrounds': []
  }

  var canvas = new fabric.Canvas('c', {
          hasControls         : false,
          allowTouchScrolling : true,
          selection           : false,
          height              : $scope.minHeight,
          width               : $scope.minWidth
        });

  $scope.asset_list   = [],
  $scope.avatar_type  = '',
  $scope.banners      = [],
  $scope.body_tone    = '',
  $scope.color_list   = [],
  $scope.init_assets  = [],
  $scope.last_svg_id  = null,
  $scope.orig_color   = [],
  $scope.scale        = (($scope.minHeight + 69) * 0.0035),
  $scope.page         = {},
  $scope.categories   = [],
  $scope.btn_disabled = {
                        'save'      : false,
                        'color'     : false,
                        'download'  : true,
                        'banner'    : true,
                        'reset'     : true,
                        'randomize' : true,
                        'spinner'   : true
                      };

    $scope.placeAsset = function(id) {
      var selected_asset = $scope.modal_content[id],
          top_offset     = null,
          svg_id         = null;
      Object.keys(canvas._objects).forEach( function(key) {
        if(canvas._objects[key].svgUid == 0) {
          top_offset = canvas._objects[key].getTop()
                     + (selected_asset.top_offset * $scope.scale);
        }
      });
      $scope.color_list             = [],
      $scope.btn_disabled.save      = false,
      $scope.btn_disabled.download  = true,
      $scope.btn_disabled.banner    = true;

      switch(selected_asset.asset_name) {
        case 'body':
          svg_id            = 0;
          $scope.color_list = selected_asset.color_palette;
          break;
        case 'hat':
          svg_id = $scope.avatar_type == 'female' ? 14 : 1;
          $scope.btn_disabled.color = false;
          break;
        case 'eyes':
          svg_id = 2;
          break;
        case 'glasses':
          svg_id                    = 3;
          $scope.btn_disabled.color = false;
          break;
        case 'mouth':
          svg_id = 4;
          break;
        case 'facial_hair':
          svg_id                    = 5;
          $scope.btn_disabled.color = false;
          break;
        case 'necklace':
          svg_id                    = 6;
          $scope.btn_disabled.color = false;
          break;
        case 'scarf':
          svg_id                    = 7;
          $scope.btn_disabled.color = false;
          break;
        case 'top':
          svg_id            = 8;
          $scope.color_list = selected_asset.color_palette;
          $scope.btn_disabled.color = true;
          break;
        case 'bottoms':
          svg_id            = 9;
          $scope.color_list = selected_asset.color_palette;
          $scope.btn_disabled.color = true;
          break;
        case 'belt':
          svg_id                    = 10;
          $scope.btn_disabled.color = false;
          break;
        case 'shoes':
          svg_id                    = 11;
          $scope.btn_disabled.color = false;
          break;
        case 'accessories':
          svg_id                    = 12;
          $scope.btn_disabled.color = false;
          break;
        case 'backgrounds':
          _removeAsset(13);
          fabric.Image.fromURL(selected_asset.thumb_path,
            function(img){
              canvas.add(img);
              img.sendToBack()
                 .set('selectable', false)
                 .set('hasControls', false)
                 .set('svgUid', 13);
            }, {
              crossOrigin: 'Access-Control-Allow-Origin : https://d2br2zq050k1df.cloudfront.net'
            }
          );
          break;
        case 'hair':
          svg_id                    = 1;
          $scope.btn_disabled.color = false;
          break;
        case 'outfit':
          svg_id            = 15;
          $scope.color_list = selected_asset.color_palette;
          $scope.btn_disabled.color = true;
          break;
        case 'tie':
          svg_id                    = 16;
          $scope.btn_disabled.color = false;
          break;
        case 'bracelet':
          svg_id                    = 17;
          $scope.btn_disabled.color = false;
          break;
        default:
          return false;
      }
      if(svg_id != null) {
        _loadSVG(selected_asset.svg,
          [
           svg_id,
           selected_asset.layer_level,
           selected_asset.left_offset,
           top_offset
          ]
        );
        $scope.last_svg_id = svg_id;
      }
      window.analytics.trackEvent('Assets',
                                  'Asset added',
                                  selected_asset.asset_type != '' ?
                                    selected_asset.asset_name
                                  + ' '
                                  + selected_asset.asset_type
                                  + ' '
                                  + selected_asset.type_id
                                  : selected_asset.asset_name
                                  + ' '
                                  + selected_asset.type_id,
                                  1);
      canvas.renderAll();
      $scope.modal.hide();
    }

    var _loadSVG = function(svg, coord_arr) {
      fabric.loadSVGFromString(svg, function(objects, options) {
        if(canvas._objects.length != 0) {
          _removeAsset(coord_arr[0]);
        }

        options.svgUid      = coord_arr[0],
        options.top         = coord_arr[3],
        options.selectable  = false,
        options.hasControls = false;
        var obj = fabric.util.groupSVGElements(objects, options);
        canvas.add(obj)
              .moveTo(obj,coord_arr[1]);
        obj.scale($scope.scale)
           .centerH()
           .set('left',obj.left + coord_arr[2] * $scope.scale)
           .setCoords();

        for(var i = 0; i<canvas._objects.length; i++) {
          if(canvas._objects[i].intersectsWithObject(obj)
          && canvas._objects[i].svgUid == obj.svgUid) {
            obj.bringForward();
            obj.setCoords();
            break;
          }
        }
        canvas.renderAll();

        Object.keys(obj.paths).forEach( function (pathIndex) {
          $scope.orig_color[pathIndex] = obj.paths[pathIndex].getFill();
        });

        if(obj.svgUid == 0) {
          $scope.changeColor($scope.body_tone, obj);
        }
        return;
      });
    }

    var _removeAsset = function(svg_id) {
      for(var i = 0; i < canvas._objects.length; i++) {
        if(canvas._objects[i].svgUid == svg_id) {
          canvas.fxRemove(canvas._objects[i]);
        }
      }
      $scope.btn_disabled.save      = false,
      $scope.btn_disabled.download  = true,
      $scope.btn_disabled.banner    = true;
    }

    $scope.removeAsset = function(asset_name) {
      var svg_id = null;
      switch(asset_name) {
        case 'body':
          return false;
        case 'hat':
          svg_id = self.avatar_type == 'female' ? 14 : 1;
          break;
        case 'eyes':
          return false;
        case 'glasses':
          svg_id = 3;
          break;
        case 'mouth':
          return false;
        case 'facial_hair':
          svg_id = 5;
          break;
        case 'necklace':
          svg_id = 6;
          break;
        case 'scarf':
          svg_id = 7;
          break;
        case 'top':
          return false;
        case 'bottoms':
          return false;
        case 'belt':
          svg_id = 10;
          break;
        case 'shoes':
          svg_id = 11;
          break;
        case 'accessories':
          svg_id = 12;
          break;
        case 'backgrounds':
          svg_id = 13;
          type   = 'undefined';
          break;
        case 'hair':
          svg_id = 1;
          break;
        case 'outfit':
          return false;
        case 'tie':
          svg_id = 16;
          break;
        case 'bracelet':
          svg_id = 17;
          break;
        default:
          return false;
      }
      _removeAsset(svg_id);
      $scope.modal.hide();
    }

    $rootScope.$on("onColorChange", function(event, color) {
      $scope.changeColor(color);
    });

    $scope.changeColor = function(color,object) {
      if(color == "") {
        Object.keys(canvas._objects).forEach(function(obj) {
          if(canvas._objects[obj].svgUid == $scope.last_svg_id) {
            Object.keys(canvas._objects[obj].paths).forEach(function(key) {
              canvas._objects[obj].paths[key].fill = $scope.orig_color[key];
            });
          }
        });
        canvas.renderAll();
        return;
      }

      if(object == null) {
        Object.keys(canvas._objects).forEach(function(objectIndex) {
          if(canvas._objects[objectIndex].svgUid == $scope.last_svg_id) {
            object = canvas._objects[objectIndex];
          }
        });
      }

      var toColor     = null,
          hexOffset   = [],
          colorAdjust = null,
          leastHexVal = 0;

      Object.keys(object.paths).forEach(function(key) {
        hexOffset[key] = parseInt($scope.orig_color[key].substr(1),16);

        if(leastHexVal < hexOffset[key]) {
          leastHexVal  = hexOffset[key];
        }
      });

      Object.keys(hexOffset).forEach(function (key) {
        hexOffset[key] = Math.abs(leastHexVal - hexOffset[key]).toString(16);
      });

      Object.keys(object.paths).forEach(function(key) {
        colorAdjust = fabric.Color.fromHex($scope.orig_color[key]);
        toColor     = fabric.Color.fromHex(color);

        if(object.paths[key].fill == 'rgb(0,0,0)'){
          object.paths[key].fill = fabric.Color.fromRgb(object.paths[key].fill);
        }
        else if(hexOffset[key] == "0"
             || colorAdjust._source == undefined) {
          object.paths[key].fill = color;
        }
        else if(hexOffset[key] != "0"
             || hexOffset[key] == NaN) {
          object.paths[key].fill = '#'
                                 + toColor.overlayWith(colorAdjust).toHex();
        }
      });
      canvas.renderAll();
      return true;
    }

    $scope.alertNotLoaded = function() {
      var alertPopup = $ionicPopup.alert({
        title: 'Could not load!',
        template: '<div style="text-align:center;">Please check your internet connection</div>'
      });
      alertPopup.then(function(res) {
        window.location.hash = "#/start";
      });
    };

    $scope.initAvatar = function(rand,color) {
      if(color) {
        $scope.body_tone = color;
      }
      if(typeof $scope.body_thumb === typeof undefined){
        maleAssets.then(function(m) {
          femaleAssets.then(function(f) {
            $scope.body_thumb = {
              male    : m.Body[0].thumb_path,
              female  : f.Body[0].thumb_path
            };
          }).catch(function(reason) {
            $scope.alertNotLoaded();
            return;
          });
        }).catch(function(reason) {
          $scope.alertNotLoaded();
          return;
        });
      }

      if(typeof(rand) != 'boolean') {
        angular.element(rand.currentTarget).parent().parent().addClass('bounceOutUp')
                                                    .addClass('hidden');
        $scope.btn_disabled.spinner = false;
        $scope.startAvatar(false);
        return;
      }
      $scope.startAvatar(rand);
    }

    $scope.setAvatarType = function(type, $event) {
      var event_element = angular.element($event.currentTarget).parent();
      event_element.parent().addClass('bounceOutUp')
                            .removeClass('bounceInUp')
                            .addClass('hidden')
                   .next().addClass('bounceInUp')
                          .removeClass('hidden');
      $scope.avatar_type = type;
      if($scope.avatar_type == 'male') {
        typeList.Head.push({title: 'Facial Hair'});
        typeList.Accessories.push({title: 'Tie'});
      }
      switch(type) {
        case 'male':
          $scope.content = maleAssets.$$state.value;
          delete $scope.content.$promise;
          delete $scope.content.$resolved;
          break;
        case 'female':
          $scope.content = femaleAssets.$$state.value;
          delete $scope.content.$promise;
          delete $scope.content.$resolved;
          break;
        default:
          break;
      }
      return;
    }

    $rootScope.$on("onStartAvatar", function(event, rand) {
      $scope.startAvatar(rand);
    });

    $scope.startAvatar = function(random) {
      $scope.btn_disabled.reset = true,
      $scope.btn_disabled.randomize = true;
      var asset_index     = 0,
          selected_asset  = [],
          avatar_top      = 0;
      Object.keys(canvas._objects).forEach (function(key) {
        canvas.fxRemove(canvas._objects[key]);
      });

      if($scope.content) {
        selected_asset  = $scope.content.Body[asset_index];
        avatar_top      = $scope.content.Body[asset_index].top_offset - 20;
      }

      if(selected_asset.svg == "" || selected_asset.svg == null) {
        return false;
      }
      $scope.color_list[0] = $scope.body_tone;
      _loadSVG(selected_asset.svg,[
               0,
               selected_asset.layer_level,
               selected_asset.left_offset,
               (avatar_top)*$scope.scale
              ]
      );

      if(random == true) {
        asset_index = Math.floor(Math.random()
        * $scope.content.Clothes['Top'].length);
      }
      $scope.color_list = [];
      selected_asset  = $scope.content.Clothes['Top'][asset_index];
      if(selected_asset.svg == "" || selected_asset.svg == null) {
        return false;
      }
      _loadSVG(selected_asset.svg,
              [8,
               selected_asset.layer_level,
               selected_asset.left_offset,
               (avatar_top+selected_asset.top_offset)*$scope.scale
              ]
      );

      if(random == true) {
        asset_index = Math.floor(Math.random()
        * $scope.content.Clothes['Bottoms'].length);
      }
      $scope.color_list = [];
      selected_asset  = $scope.content.Clothes['Bottoms'][
        asset_index
      ];
      if(selected_asset.svg == "" || selected_asset.svg == null) {
        return false;
      }
      _loadSVG(selected_asset.svg,
              [9,
               selected_asset.layer_level,
               selected_asset.left_offset,
               (avatar_top+selected_asset.top_offset)*$scope.scale
              ]
      );

      if(random == true) {
        asset_index = Math.floor(Math.random()
        * $scope.content.Head['Mouth'].length);
      }
      $scope.color_list = [];
      selected_asset  = $scope.content.Head['Mouth'][
        asset_index
      ];
      if(selected_asset.svg == "" || selected_asset.svg == null) {
        return false;
      }
      _loadSVG(selected_asset.svg,
              [4,
               selected_asset.layer_level,
               selected_asset.left_offset,
               (avatar_top+selected_asset.top_offset)*$scope.scale
              ]
      );

      if(random == true) {
        asset_index = Math.floor(Math.random()
        * $scope.content.Head['Eyes'].length);
      }
      $scope.color_list = [];
      selected_asset  = $scope.content.Head['Eyes'][
        asset_index
      ];
      if(selected_asset.svg == "" || selected_asset.svg == null) {
        return false;
      }
      _loadSVG(selected_asset.svg,
              [2,
               selected_asset.layer_level,
               selected_asset.left_offset,
               (avatar_top+selected_asset.top_offset)*$scope.scale
              ]
      );

      if(random == true) {
        asset_index = Math.floor(Math.random()
        * $scope.content.Head['Hair'].length);
      }
      $scope.color_list = [];
      selected_asset  = $scope.content.Head['Hair'][
        asset_index
      ];
      if(selected_asset.svg == "" || selected_asset.svg == null) {
        return false;
      }
      _loadSVG(selected_asset.svg,
              [1,
               selected_asset.layer_level,
               selected_asset.left_offset,
               (avatar_top+selected_asset.top_offset)*$scope.scale
              ]
      );
      $ionicNavBarDelegate.showBar(true);
      $scope.init_assets            = [],
      $scope.last_svg_id            = 1,
      $scope.btn_disabled.spinner   = true,
      $scope.btn_disabled.save      = false,
      $scope.btn_disabled.download  = true,
      $scope.btn_disabled.banner    = true,
      $scope.btn_disabled.reset     = false,
      $scope.btn_disabled.randomize = false;

    }

    $scope.resetAvatar = function(rand) {
      $scope.btn_disabled.spinner = true;
      switch(rand) {
        case true:
          $scope.initAvatar(rand);
          break;
        case false:
          $scope.avatar_type = '',
          $scope.last_svg_id = null;
          $scope.initAvatar(rand);
          break;
        default:
          return false;
      }
    }

    $rootScope.$on("onSaveAvatar", function() {
      $scope.saveAvatar();
    });

    $scope.saveAvatar = function() {
      try {
        cordova.base64ToGallery(canvas.toDataURL(),
                                {
                                  prefix: 'avatar_',
                                  mediaScanner: true
                                },
                                function(msg) {
                                  $scope.btn_disabled.download  = false,
                                  $scope.btn_disabled.banner    = false;
                                },
                                function(e) {
                                  $scope.btn_disabled.save = false;
                                });
      } catch (e) {
      } finally {
        $scope.modal.hide();
      }
    }

    $scope.loadAvatar = function() {
      $scope.last_svg_id = null,
      $scope.avatar_type = '',
      $scope.resetAvatar(false);
    }

    $scope.loadAvatar();

  $ionicModal.fromTemplateUrl('templates/modal.html', {
    backdropClickToClose: false,
    hardwareBackButtonClose: false,
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    $scope.modal = modal;
    $scope.last_tab = [];
  });

  $scope.openModal = function(type) {

    $scope.type = type;
    $scope.secondTabs = typeList[type];
    if($scope.last_tab[type]) {
      $scope.selectSecondaryTab(type,$scope.last_tab[type]);
      $scope.modal.show();
      return;
    }

    // grab index 0 from api type by default
    switch(type) {
      case 'Shoes':
        $scope.modal_content = $scope.content[type];
        break;
      case 'Backgrounds':
        $scope.modal_content = $scope.content[type];
        break;
      default:
        for(subcat in $scope.content[type]) break;
        $scope.modal_content = $scope.content[type][subcat];
        break;
    }

    $scope.modal.show();
  };
  $scope.closeModal = function(type, index) {
    $scope.modal_content = [];
    if(index != undefined && index != 'backgrounds' && index != 'shoes') {
      index = index.charAt(0).toUpperCase() + index.slice(1);
      $scope.last_tab[type] = index.replace('_',' ');
    }
    $scope.modal.hide();
  };
  // Cleanup the modal when we're done with it!
  $scope.$on('$destroy', function() {
    $scope.modal.remove();
  });
  // Execute action on hide modal
  $scope.$on('modal.hidden', function() {
    // Execute action
  });
  // Execute action on remove modal
  $scope.$on('modal.removed', function() {
    // Execute action
  });

  $scope.selectSecondaryTab = function(type, index) {
    // select new secondary tab
    $scope.modal_content = $scope.content[type][index];
  }

}])

.controller('MenuCtrl',['$scope','$ionicPopup','$rootScope','$ionicSideMenuDelegate', function($scope, $ionicPopup, $rootScope, $ionicSideMenuDelegate) {
  $scope.active = false;
  $scope.toggleLeft = function() {
    $ionicSideMenuDelegate.toggleLeft();
  }

  $scope.alertSave = function() {
    var alertPopup = $ionicPopup.alert({
      title: 'Saved!',
      template: '<div style="text-align:center;">Your avatar has been saved</div>'
    });
    alertPopup.then(function(res) {
      console.log("Saved to device storage");
    });
  };

  $scope.saveAvatar = function() {
    $rootScope.$emit("onSaveAvatar", {});
    $rootScope.$on('$stateChangeStart', function(event,toState,toParams,fromState,fromParams) {
      if(toState.url == "/start") {
        event.preventDefault();
      }
    });
    $scope.alertSave();
    $scope.toggleLeft();
  }

  $scope.startAvatar = function(rand) {
    $rootScope.$emit("onStartAvatar", rand);
    $rootScope.$on('$stateChangeStart', function(event,toState,toParams,fromState,fromParams) {
      if(toState.url == "/start") {
        event.preventDefault();
      }
    });
    $scope.toggleLeft();
  }

  $scope.changeColor = function(color) {
    $rootScope.$emit("onColorChange", color);
    $scope.toggleLeft();
  }

}])

.controller('StartCtrl', function($scope, $window) {

  $scope.minHeight = $window.innerHeight;

  $scope.GotoLink = function (url) {
    window.open(url, '_system');
  }

});
